/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Hultmann Extensions.
 *
 * The Initial Developer of the Original Code is
 * Jeferson Hultmann <hultmann@gmail.com>
 * Portions created by the Initial Developer are Copyright (C) 2009
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either of the GNU General Public License Version 2 or later (the "GPL"),
 * or the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

const EXPORTED_SYMBOLS = ['util2', 'PUBLIC_asyncConfigMenuItems'];

Components.utils.import("resource://hultmann-js-migre-me/util.js");


/*
<INPUT EDIT>    LONG_URL
  *  Compactar com tinyurl: "http://longurl.com/..."

<INPUT READONLY>LONG_URL
  *  Copiar como tinyurl.com "http://longurl.com/..."


<INPUT EDIT>    SHORT_URL
   ! http://longurl.com/...>  Descompactar           [input=>replace]
                              Converter para tinyurl [input=>convert_replace]  (p/ SHORT_URL!=tinyurl)
<INPUT READONLY>SHORT_URL
   ! http://longurl.com/...>  Copiar                 [input=>copy]
                              Copiar como tinyurl    [input=>convert_copy]      (p/ SHORT_URL!=tinyurl)

<A>             SHORT_URL
  ! http://longurl.com/...>   Copiar                 [link=>copy]
                              Copiar como tinyurl    [link=>convert_copy]       (p/ SHORT_URL!=tinyurl)
*/
//menuItem.style.width='40em';//436px
//menuItem.style.width='30em';//326px
//menuItem.style.width='28em';
/*
util.log(doc.defaultView.getComputedStyle(menuItem, '').getPropertyValue("width"));
util.log(menuItem.ownerDocument.defaultView.getComputedStyle(menuItem, '').getPropertyValue("width"));
util.log(menuItem.ownerDocument.defaultView.getComputedStyle(menuItem, '').getPropertyCSSValue("width").cssText);
util.log(menuItem.ownerDocument.defaultView.getComputedStyle(menuItem, '').width);
*/


function PUBLIC_asyncConfigMenuItems(popupNode, cmdData) {
  if (util2.isOffline()) {
    return;
  }

  var doc = popupNode.ownerDocument;
  var browser = doc.defaultView.gBrowser.selectedBrowser;

  function onUncompress(longUri) {

    var cascadeMenu = doc.getElementById('hultmann-migre-me-cascade');
    if (cascadeMenu === null) {
      // menu is gone
      return;
    }

    var popupCascadeMenu = cascadeMenu.appendChild(doc.createElement('menupopup'));
    var pathMenuItem = popupCascadeMenu.appendChild(doc.createElement('menuitem'));
    var sepItem2 = popupCascadeMenu.appendChild(doc.createElement('menuseparator'));
    var copyMenuItem = popupCascadeMenu.appendChild(doc.createElement('menuitem'));
    var convertMenuItem = popupCascadeMenu.appendChild(doc.createElement('menuitem'));


    cascadeMenu.addEventListener('popuphidden', onPopupHidden, false);
    cascadeMenu.setAttribute('label', longUri.prePath);
    switch (longUri.scheme) {
      case 'http':
      case 'https':
        cascadeMenu.setAttribute('accesskey', 'h');
        break;
    }
    var sublabel = "\u2026" + longUri.path;


    var title = util2.getTitleFromHistory(longUri);
    //historyService.hasHistoryEntries;


    pathMenuItem.setAttribute('crop', 'center');
    pathMenuItem.setAttribute('label', sublabel);
    if (title) {
      pathMenuItem.setAttribute('description', title);
      pathMenuItem.setAttribute('tooltiptext', title + '\n' + longUri.spec);
    } else {
      pathMenuItem.setAttribute('tooltiptext', longUri.spec);
    }

    util2.setStatusBar(longUri.spec, pathMenuItem);

    if (cascadeMenu.value !== 'link') {
      // input
      cascadeMenu.setAttribute('tooltiptext', cmdData.uri.spec);
    } else {
      if (title) {
        cascadeMenu.setAttribute('tooltiptext', title);
      }
    }

    copyMenuItem.setAttribute('tooltiptext', '');
    convertMenuItem.setAttribute('tooltiptext', '');
    sepItem2.setAttribute('tooltiptext', '');

    // moz-anno:favicon:http://blog.mozilla.com/favicon.ico
    var fav = util2.getFavicon(longUri);
    cascadeMenu.setAttribute('image', fav);
    pathMenuItem.setAttribute('image', fav);
    pathMenuItem.setAttribute('class', 'menuitem-iconic');


    copyMenuItem.addEventListener('command', new OnLongUriCmds(cmdData, longUri, browser), false);
    convertMenuItem.addEventListener('command', new OnLongUriCmds(cmdData, longUri, browser), false);

    pathMenuItem.addEventListener('command',
      function(evt) {
        util2.openPage(evt, browser, longUri.spec, false);
      },
      false);
    pathMenuItem.addEventListener('click',
      function(evt) {
        util2.openPage(evt, browser, longUri.spec, true);
      },
      false);

    cascadeMenu.setAttribute('disabled', 'false');
    switch (cascadeMenu.value) {
      case 'link':
        copyMenuItem.value = 'link=>copy';
        copyMenuItem.setAttribute('label', util.getText('context.link.loaded.label'));
        copyMenuItem.setAttribute('accesskey', util.getText('context.link.loaded.accesskey'));

        convertMenuItem.value = 'link=>convert_copy';
        convertMenuItem.hidden = cmdData.uri.host === 'migre.me';
        convertMenuItem.setAttribute('label', util.getText('context.link.convertCopy.label', 'migre.me'));
        convertMenuItem.setAttribute('accesskey', util.getText('context.link.convertCopy.accesskey'));
        break;

      case 'inputEdit':
        copyMenuItem.value = 'input=>replace';
        copyMenuItem.setAttribute('label', util.getText('context.replaceUncompressed.label'));
        copyMenuItem.setAttribute('accesskey', util.getText('context.replaceUncompressed.accesskey'));

        convertMenuItem.value = 'input=>convert_replace';
        convertMenuItem.hidden = cmdData.uri.host === 'migre.me';
        convertMenuItem.setAttribute('label', util.getText('context.replaceCompetitorUrl.label', 'migre.me'));
        convertMenuItem.setAttribute('accesskey', util.getText('context.replaceCompetitorUrl.accesskey'));
        break;

      case 'inputReadOnly':
        copyMenuItem.value = 'input=>copy';
        copyMenuItem.setAttribute('label', util.getText('context.copyUncompressed.label'));
        copyMenuItem.setAttribute('accesskey', util.getText('context.copyUncompressed.accesskey'));

        convertMenuItem.hidden = cmdData.uri.host === 'migre.me';
        convertMenuItem.value = 'input=>convert_copy';
        convertMenuItem.setAttribute('label', util.getText('context.copyCompetitorUrl.label', 'migre.me'));
        convertMenuItem.setAttribute('accesskey', util.getText('context.copyCompetitorUrl.accesskey'));
        break;

      default:
        util.myThrow(cascadeMenu.value);
        break;
    }

  }

  function onError(errData) {
    util.log('FAIL ' + errData.toSource());
    if (popupNode.state !== 'open') {
      return;
    }

    var cmdShow = function(evt) {
      Components.utils.import("resource://hultmann-js-migre-me/err.js");
      notificationError(errData, browser);
    };

    var cascadeMenu = doc.getElementById('hultmann-migre-me-cascade');
    cascadeMenu.addEventListener('popuphidden', onPopupHidden, false);
    var menu2 = cascadeMenu.appendChild(doc.createElement('menupopup'));
    var menu3 = menu2.appendChild(doc.createElement('menuitem'));
    menu3.setAttribute('label', util.getText('context.error.label'));
    menu3.setAttribute('accesskey', util.getText('context.error.accesskey'));
    menu3.addEventListener('command', cmdShow, false);

    cascadeMenu.setAttribute('image', 'chrome://global/skin/icons/warning-16.png');
    cascadeMenu.setAttribute('disabled', 'false');


    /*
    var showInfo;
    var active = function(evt) {
      showInfo = function() {
        menu.removeEventListener('DOMMenuItemActive', active, false);
        Components.utils.import("resource://hultmann-js-migre-me/err.js");
        notificationError(errData, browser);
      };
      doc.defaultView.setTimeout(function() { showInfo(); }, 300);
    };
    menu.addEventListener('DOMMenuItemActive', active, false);
    menu.addEventListener('DOMMenuItemInactive', function(evt) {
      showInfo = function(){};
    }, false);
    */
  }
  util2.toggleUrl(cmdData.uri, browser, onUncompress, onError);
}




function onPopupHidden(evt) {
  evt.stopPropagation();
}

function OnLongUriCmds(c, l, b) {
  this.cmdData = c;
  this.longUri = l;
  this.browserOrigin = b;
}

OnLongUriCmds.prototype = {

  handleEvent: function(evt) {
    var menuItem = evt.target;
    var c = menuItem.value.split('=>')[1];
    switch (c) {
      case 'convert_copy':
      case 'convert_replace':
      case 'copy':
      case 'replace':
        this[c]();
        break;
      default:
        util.myThrow(c);
        break;
    }
  },

  copy: function() {
    util2.toClipboard(this.longUri.spec);
  },

  replace: function() {
    Components.utils.import("resource://hultmann-js-migre-me/run-input.js");
    PUBLIC_replaceCore(this.cmdData, this.longUri, this.browserOrigin);
  },

  convert_copy: function() {
    util2.toClipboard('');
    var callback = function(myUri) {
      util2.toClipboard(myUri.spec);
    };
    util2.toggleUrl(this.longUri, this.browserOrigin, callback);
  },

  convert_replace: function() {
    var b = this.browserOrigin;
    var me = this;
    var callback = function(myUri) {
      Components.utils.import("resource://hultmann-js-migre-me/run-input.js");
      PUBLIC_replaceCore(me.cmdData, myUri, b);
    }
    util2.toggleUrl(this.longUri, b, callback);
  }
}



const util2 = {

  openPage: function(evt, browser, url, middleClick) {
    var menuItem = evt.target;
    if (middleClick) {
      if (evt.button !== 1 || menuItem.getAttribute("disabled") === "true") {
        return;
      }
    }

    var chrWnd = browser.ownerDocument.defaultView;
    chrWnd.closeMenus(menuItem);
    var referer = browser.contentDocument.documentURIObject;
    var where = middleClick ? 'tabshifted' : 'current';
    chrWnd.openUILinkIn(url, where, false, null, referer);
  },

  getTitleFromHistory: function(uri) {
    var historyService = Components
                          .classes["@mozilla.org/browser/nav-history-service;1"]
                          .getService(Components.interfaces.nsINavHistoryService);
    return historyService.getPageTitle(uri);
    //historyService.hasHistoryEntries;
  },


  getFavicon: function(uri) {
    return Components
            .classes["@mozilla.org/browser/favicon-service;1"]
            .getService(Components.interfaces.nsIFaviconService)
            .getFaviconImageForPage(uri)
            .spec;
  },

  toClipboard: function(txt) {
    Components
      .classes['@mozilla.org/widget/clipboardhelper;1']
      .getService(Components.interfaces.nsIClipboardHelper)
      .copyString(txt);
  },

  isOffline: function() {
    return Components
            .classes['@mozilla.org/network/io-service;1']
            .getService(Components.interfaces.nsIIOService2)
            .offline;
  },

  setStatusBar: function(txt, menuItem) {
    var statusHandler = menuItem.ownerDocument.defaultView.XULBrowserWindow;
    menuItem.addEventListener('DOMMenuItemActive', function(evt) {
      statusHandler.setOverLink(txt);
    }, false);
    menuItem.addEventListener('DOMMenuItemInactive', function(evt) {
      statusHandler.setOverLink('');
    }, false);
  },

  formatUrl: {
    crop: function(uri) {
      var max = 42;
      var full = uri.spec;
      if (full.length < max || util.isShortHost(uri.host)) {
        return {item:full, tooltip:''};
      }

      // without http://
      var txt = full.replace(/^https?:\/\//i, '');
      if (uri.path.length === 1) {
        txt = txt.substr(0, txt.length - 1); // remove trailing '/'
      }
      if (txt.length < max) {
        return {item:txt, tooltip:full};
      }

      // no path: send domain
      if (uri.path.length === 1) { // = '/'
        return {item:txt, tooltip:full};
      }

      /*
      // without www.
      txt = txt.replace(/^www\./i, '');
      if (txt.length < max) {
        return {item:txt, tooltip:full};
      }*/

      //var maxPath = 20;
      //max -= uri.host.length;

      // z.com/xx-ddd-a
      var len = txt.indexOf('/');

      // small path
      if ((len + uri.path.length) <= max) {
        return {item:txt, tooltip:full};
      }

      // 012345678901234567890123456789
      // br.mozdev.org                 len    = 13
      // /firefox/backup-dos-favoritos lenPath= 29

      // trim at words
      var lenPath = 0;
      var lenTrim;
      do {
        lenTrim = lenPath;
        lenPath = this._indexOfNextStopWord(uri.path, lenPath + 1);
        if (lenPath === -1) {
          break;
        }
      } while((len + lenPath) <= max);


      // trim path
      var uri2 = uri.clone();
      uri2.path = uri2.path.substr(0, lenTrim);
      txt = uri2.spec.replace(/^https?:\/\//i, '');
      //txt = txt.replace(/^www\./i, '');
      return {item:txt + "\u2026", tooltip:full};
    },

    _indexOfNextStopWord: function(path, idxStart) {
      var idx = this._indexOf(path, ['/', '&', '.', '?', '-', '_'], idxStart);
      if (idx !== Infinity) {
        return idx;
      }

      /*
      var idx = this._indexOf(path, ['/', '&'], idxStart);
      if (idx !== Infinity) {
        return idx;
      }

      idx = this._indexOf(path, ['.', '?'], idxStart);
      if (idx !== Infinity) {
        return idx;
      }*/

      return -1;
    },

    _indexOf: function(path, bounds, idxStart) {
      var mySort = function(a, b) {
        return a - b;
      };
      var stopChars = bounds.map(function(myChar) {
        var idx2 = path.indexOf(myChar, idxStart);
        return idx2 === -1 ? Infinity : idx2;
      });
      stopChars.sort(mySort);
      return stopChars[0];
    }

  },

  toggleUrl: function(uri, browser, success, error) {
    if (util.isShortHost(uri.host)) {
      toLongUrlRequest(browser, uri, success, error);
    } else {
      toTinyUrlRequest(browser, uri, success, error);
    }
  }

};




function toLongUrlRequest(browserOrigin, uri, success, error) {
  if (util.isShortHost(uri.host) == false) {
    util.myThrow(uri.host);
  }

  switch (uri.host) {
    case 'migre.me':
      Components.utils.import("resource://hultmann-js-migre-me/api-migreme.js");
      break;
    default:
      Components.utils.import("resource://hultmann-js-migre-me/api-longurlplease.js");
      break;
  }

  var chromeWnd = browserOrigin.ownerDocument.defaultView;
  var req = new AsyncRequest();
  var started;

  req.onStart = function() {
    started = new Date().getTime();
    chromeWnd.setCursor('progress');
  };

  req.onStop = function() {
    chromeWnd.setCursor('auto');
    util.log('longurlplease/m.m connection: ' + (new Date().getTime() - started) + 'ms');
  };

  req.onSuccess = success;

  if (error) {
    req.onError = error;
  } else {
    req.onError = function(errData) {
      Components.utils.import("resource://hultmann-js-migre-me/err.js");
      notificationError(errData, browserOrigin);
    }
  }

  req.restore(uri);
}


function toTinyUrlRequest(browserOrigin, uri, success, error) {
  if (util.isShortHost(uri.host)) {
    util.myThrow(host);
  }

  Components.utils.import("resource://hultmann-js-migre-me/api-migreme.js");

  var chromeWnd = browserOrigin.ownerDocument.defaultView;
  var req = new AsyncRequest();
  var started;

  req.onStart = function() {
    chromeWnd.setCursor('progress');
    started = new Date().getTime();
    /*
    var e = chromeWnd.document.documentElement;
    util.log('onstart ['+e.className+']');
    e.className = (e.className ? " " : "") + 'migreme-hltmnn-progress';

    //chromeWnd.chromeWnd.gBrowser.selectedBrowser.defaultView.setCursor('progress');

    e = chromeWnd.gBrowser.selectedBrowser.contentDocument.body;
    util.log('onstart ['+e.className+']');
    e.className = (e.className ? " " : "") + 'migreme-hltmnn-progress';
    */
  };

  req.onStop = function() {
    util.log('migre.me connection: ' + (new Date().getTime() - started) + 'ms');
    /*
    var e = chromeWnd.document.documentElement;
    util.log('onstop ['+e.className+']');
    var t = e.className.split(/\s+/).map(function(i) {
      return i == 'migreme-hltmnn-progress' ? '' : i;
    });
    e.className = t.join(' ');
    */
    //util.log('cursor auto');
    chromeWnd.setCursor('auto');
  };

  req.onSuccess = success;

  if (error) {
    req.onError = error;
  } else {
    req.onError = function(errData) {
      Components.utils.import("resource://hultmann-js-migre-me/err.js");
      notificationError(errData, browserOrigin);
    }
  }

  req.convert(uri);
}
